clear
clc

%Dataset loading
a=load('housing.data');

%Data preprocessing
a(:,1:end-1)=mapminmax(a(:,1:end-1)',-1,1)';
a(:,end)=mapminmax(a(:,end)',-1,1)';
pT=0.5;

number_samples=size(a,1);
[trainInd,valInd]=divideind(number_samples,1:round(number_samples*pT),round(number_samples*pT)+1:number_samples,[]);
P=a(trainInd,1:end-1)';T=a(trainInd,end)';TV.P=a(valInd,1:end-1)';TV.T=a(valInd,end)';
NumberofTrainingData=size(P,2);
[~,valInd] = dividerand(NumberofTrainingData,0.7,0.3,0);
VV.P = P(:,valInd);
VV.T = T(:,valInd);
P(:,valInd)=[];
T(:,valInd)=[];

%Train of the SLFN network using the O-ELM framework
NN=30;%maximum number of neurons
Method='DE';%Optimization method (GA, DE, or SA)
MaxIter=100;%Maximum number of iterations
PopSize=30;%Population size
[bestW,bestWO,bestNetDef,bestRP,bestIn,tElapsed]=OELM_Train(P,T,VV.P,VV.T,NN,Method,MaxIter,PopSize);

%Test the performance of the SLFN using the network obtained by the O-ELM
[y_train,TrainingAccuracy]=OELM_Predict(bestNetDef,bestW,bestWO,P(bestIn,:),T);
[y_test,TestingAccuracy]=OELM_Predict(bestNetDef,bestW,bestWO,TV.P(bestIn,:),TV.T);

subplot(2,1,1)
plot([y_train;T]')
title('Train Set')
legend('Estimated Output','Desired Output')
xlabel('Samples')
ylabel('Outputs')
subplot(2,1,2)
plot([y_test;TV.T]')
title('Test Set')
legend('Estimated Output','Desired Output')
xlabel('Samples')
ylabel('Outputs')

fprintf('The fitting performace in training set was (RMSE): %f.\n',TrainingAccuracy);
fprintf('The fitting performace in testing set was (RMSE): %f.\n',TestingAccuracy);